diff --git a/examples/dpdk_qat/crypto.c b/examples/dpdk_qat/crypto.c
index f0471e0..b3955f7 100644
--- a/examples/dpdk_qat/crypto.c
+++ b/examples/dpdk_qat/crypto.c
@@ -720,7 +720,7 @@ per_core_crypto_init(uint32_t lcore_id)
 	}
 
 	/*
-	 * Set the address translation callback for virtual to physcial address
+	 * Set the address translation callback for virtual to physical address
 	 * mapping. This will be called by the QAT driver during initialisation only.
 	 */
 	status = cpaCySetAddressTranslation(qaCoreConf[lcore_id].instanceHandle,
diff --git a/examples/l3fwd-power/main.c b/examples/l3fwd-power/main.c
index f6b55b9..cc8bc1e 100644
--- a/examples/l3fwd-power/main.c
+++ b/examples/l3fwd-power/main.c
@@ -935,7 +935,7 @@ main_loop(__attribute__((unused)) void *dummy)
  				 */
 				rte_delay_us(lcore_idle_hint);
 			else
-				/* long sleep force runing thread to suspend */
+				/* long sleep force running thread to suspend */
 				usleep(lcore_idle_hint);
 
 			stats[lcore_id].sleep_time += lcore_idle_hint;
diff --git a/examples/l3fwd/main.c b/examples/l3fwd/main.c
index 6f7d7d4..b06f0ba 100644
--- a/examples/l3fwd/main.c
+++ b/examples/l3fwd/main.c
@@ -1256,7 +1256,7 @@ processx4_step3(struct rte_mbuf *pkt[FWDSTEP], uint16_t dst_port[FWDSTEP])
  * Suppose we have array of destionation ports:
  * dst_port[] = {a, b, c, d,, e, ... }
  * dp1 should contain: <a, b, c, d>, dp2: <b, c, d, e>.
- * We doing 4 comparisions at once and the result is 4 bit mask.
+ * We doing 4 comparsions at once and the result is 4 bit mask.
  * This mask is used as an index into prebuild array of pnum values.
  */
 static inline uint16_t *
diff --git a/examples/multi_process/l2fwd_fork/flib.h b/examples/multi_process/l2fwd_fork/flib.h
index 711e3b6..1064c9b 100644
--- a/examples/multi_process/l2fwd_fork/flib.h
+++ b/examples/multi_process/l2fwd_fork/flib.h
@@ -120,7 +120,7 @@ int flib_register_slave_exit_notify(unsigned slave_id,
 /**
  * Assign a lcore ID to non-slave thread.  Non-slave thread refers to thread that
  * not created by function rte_eal_remote_launch or rte_eal_mp_remote_launch.
- * These threads can either bind lcore or float among differnt lcores.
+ * These threads can either bind lcore or float among different lcores.
  * This lcore ID will be unique in multi-thread or multi-process DPDK running
  * environment, then it can benefit from using the cache mechanism provided in
  * mempool library.
diff --git a/examples/netmap_compat/lib/compat_netmap.c b/examples/netmap_compat/lib/compat_netmap.c
index 1d86ef0..0e8e838 100644
--- a/examples/netmap_compat/lib/compat_netmap.c
+++ b/examples/netmap_compat/lib/compat_netmap.c
@@ -160,7 +160,7 @@ mbuf_to_slot(struct rte_mbuf *mbuf, struct netmap_ring *r, uint32_t index)
 /**
  * Given a Netmap ring and a slot index for that ring, construct a dpdk mbuf
  * from the data held in the buffer associated with the slot.
- * Allocation/deallocation of the dpdk mbuf are the responsability of the
+ * Allocation/deallocation of the dpdk mbuf are the responsibility of the
  * caller.
  * Note that mbuf chains are not supported.
  */
diff --git a/examples/vhost/main.c b/examples/vhost/main.c
index 3a35359..c42c9d1 100644
--- a/examples/vhost/main.c
+++ b/examples/vhost/main.c
@@ -1326,7 +1326,7 @@ switch_worker(__attribute__((unused)) void *arg)
 
 /*
  * This function gets available ring number for zero copy rx.
- * Only one thread will call this funciton for a paticular virtio device,
+ * Only one thread will call this funciton for a particular virtio device,
  * so, it is designed as non-thread-safe function.
  */
 static inline uint32_t __attribute__((always_inline))
@@ -1342,7 +1342,7 @@ get_available_ring_num_zcp(struct virtio_net *dev)
 /*
  * This function gets available ring index for zero copy rx,
  * it will retry 'burst_rx_retry_num' times till it get enough ring index.
- * Only one thread will call this funciton for a paticular virtio device,
+ * Only one thread will call this funciton for a particular virtio device,
  * so, it is designed as non-thread-safe function.
  */
 static inline uint32_t __attribute__((always_inline))
@@ -2413,8 +2413,8 @@ destroy_device (volatile struct virtio_net *dev)
 }
 
 /*
- * Calculate the region count of physical continous regions for one particular
- * region of whose vhost virtual address is continous. The particular region
+ * Calculate the region count of physical continuous regions for one particular
+ * region of whose vhost virtual address is continuous. The particular region
  * start from vva_start, with size of 'size' in argument.
  */
 static uint32_t
@@ -2462,9 +2462,9 @@ check_hpa_regions(uint64_t vva_start, uint64_t size)
 }
 
 /*
- * Divide each region whose vhost virtual address is continous into a few
+ * Divide each region whose vhost virtual address is continuous into a few
  * sub-regions, make sure the physical address within each sub-region are
- * continous. And fill offset(to GPA) and size etc. information of each
+ * continuous. And fill offset(to GPA) and size etc. information of each
  * sub-region into regions_hpa.
  */
 static uint32_t
diff --git a/examples/vhost_xen/main.c b/examples/vhost_xen/main.c
index b4a86e3..3e064d2 100644
--- a/examples/vhost_xen/main.c
+++ b/examples/vhost_xen/main.c
@@ -561,7 +561,7 @@ gpa_to_vva(struct virtio_net *dev, uint64_t guest_pa)
 /*
  * This function adds buffers to the virtio devices RX virtqueue. Buffers can
  * be received from the physical port or from another virtio device. A packet
- * count is returned to indicate the number of packets that were succesfully
+ * count is returned to indicate the number of packets that were successfully
  * added to the RX queue.
  */
 static inline uint32_t __attribute__((always_inline))
diff --git a/examples/vhost_xen/xenstore_parse.c b/examples/vhost_xen/xenstore_parse.c
index 9441639..c444d08 100644
--- a/examples/vhost_xen/xenstore_parse.c
+++ b/examples/vhost_xen/xenstore_parse.c
@@ -299,7 +299,7 @@ err:
 }
 
 /*
- * This function maps grant node of vring or mbuf pool to a continous virtual address space,
+ * This function maps grant node of vring or mbuf pool to a continuous virtual address space,
  * and returns mapped address, pfn array, index array
  * @param gntnode
  *  Pointer to grant node
@@ -468,7 +468,7 @@ cleanup_mempool(struct xen_mempool *mempool)
 
 /*
  * process mempool node idx#_mempool_gref, idx = 0, 1, 2...
- * untill we encounter a node that doesn't exist.
+ * until we encounter a node that doesn't exist.
  */
 int
 parse_mempoolnode(struct xen_guest *guest)